/*
 * control.hpp
 *
 * This file is part of Knights.
 *
 * Copyright (C) Stephen Thompson, 2006 - 2009.
 * Copyright (C) Kalle Marjola, 1994.
 *
 * Knights is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Knights is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Knights.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef CONTROL_HPP
#define CONTROL_HPP

#include "user_control.hpp"

#include <vector>
using namespace std;

class Action;

//
// 'Controls' represent something a knight can do.
// (eg move, activate, pick up item).
//

class Control : public UserControl {
public:
    Control(int id, const Graphic *menu_gfx, MapDirection menu_dir,
            int tap_pri, bool cts, unsigned int special,
            const Action *action_)
        : UserControl(id, menu_gfx, menu_dir, tap_pri, cts, special),
          action(action_)
    { }

    // action to run when the control is selected.
    const Action * getAction() const { return action; }

private:
    const Action *action;
};

#endif
